Package org.sqlite.date

## Class FastDatePrinter

- java.lang.Object
- - org.sqlite.date.FastDatePrinter

All Implemented Interfaces:
  `Serializable`, `DatePrinter`

    public class FastDatePrinter
    extends Object
    implements DatePrinter, Serializable

FastDatePrinter is a fast and thread-safe version of `SimpleDateFormat`.

To obtain a FastDatePrinter, use `FastDateFormat.getInstance(String, TimeZone, Locale)` or another variation of the factory methods of `FastDateFormat`.

Since FastDatePrinter is thread safe, you can use a static member instance: `private static final DatePrinter DATE_PRINTER = FastDateFormat.getInstance("yyyy-MM-dd");`

This class can be used as a direct replacement to `SimpleDateFormat` in most formatting situations. This class is especially useful in multi-threaded server environments. `SimpleDateFormat` is not thread-safe in any JDK version, nor will it be as Sun have closed the bug/RFE.

Only formatting is supported by this class, but all patterns are compatible with SimpleDateFormat (except time zones and some year patterns - see below).

Java 1.4 introduced a new pattern letter, `'Z'`, to represent time zones in RFC822 format (eg. `+0800` or `-1100`). This pattern letter can be used here (on all JDK versions).

In addition, the pattern `'ZZ'` has been made to represent ISO 8601 full format time zones (eg. `+08:00` or `-11:00`). This introduces a minor incompatibility with Java 1.4, but at a gain of useful functionality.

Starting with JDK7, ISO 8601 support was added using the pattern `'X'`. To maintain compatibility, `'ZZ'` will continue to be supported, but using one of the `'X'` formats is recommended.

Javadoc cites for the year pattern: For formatting, if the number of pattern letters is 2, the year is truncated to 2 digits; otherwise it is interpreted as a number. Starting with Java 1.7 a pattern of 'Y' or 'YYY' will be formatted as '2003', while it was '03' in former Java versions. FastDatePrinter implements the behavior of Java 7.

Since:
  3.2
Version:
  $Id$
See Also:
  `FastDateParser`, Serialized Form

### Field Summary

Fields
`static int` `FULL` FULL locale dependent date or time style.
`static int` `LONG` LONG locale dependent date or time style.
`static int` `MEDIUM` MEDIUM locale dependent date or time style.
`static int` `SHORT` SHORT locale dependent date or time style.

### Constructor Summary

Constructors
`protected` `FastDatePrinter​(String pattern, TimeZone timeZone, Locale locale)` Constructs a new FastDatePrinter.

### Method Summary

All Methods Instance Methods Concrete Methods
`protected StringBuffer` `applyRules​(Calendar calendar, StringBuffer buf)` Performs the formatting by applying the rules to the specified calendar.
`boolean` `equals​(Object obj)` Compares two objects for equality.
`String` `format​(long millis)` Formats a millisecond `long` value.
`StringBuffer` `format​(long millis, StringBuffer buf)` Formats a millisecond `long` value into the supplied `StringBuffer`.
`StringBuffer` `format​(Object obj, StringBuffer toAppendTo, FieldPosition pos)` Formats a `Date`, `Calendar` or `Long` (milliseconds) object.
`String` `format​(Calendar calendar)` Formats a `Calendar` object.
`StringBuffer` `format​(Calendar calendar, StringBuffer buf)` Formats a `Calendar` object into the supplied `StringBuffer`.
`String` `format​(Date date)` Formats a `Date` object using a `GregorianCalendar`.
`StringBuffer` `format​(Date date, StringBuffer buf)` Formats a `Date` object into the supplied `StringBuffer` using a `GregorianCalendar`.
`Locale` `getLocale()` Gets the locale used by this printer.
`int` `getMaxLengthEstimate()` Gets an estimate for the maximum string length that the formatter will produce.
`String` `getPattern()` Gets the pattern used by this printer.
`TimeZone` `getTimeZone()` Gets the time zone used by this printer.
`int` `hashCode()` Returns a hashcode compatible with equals.
`protected List<org.sqlite.date.FastDatePrinter.Rule>` `parsePattern()` Returns a list of Rules given a pattern.
`protected String` `parseToken​(String pattern, int[] indexRef)` Performs the parsing of tokens.
`protected org.sqlite.date.FastDatePrinter.NumberRule` `selectNumberRule​(int field, int padding)` Gets an appropriate rule for the padding required.
`String` `toString()` Gets a debugging string version of this formatter.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### FULL

    public static final int FULL

FULL locale dependent date or time style.

See Also:
  Constant Field Values

#### LONG

    public static final int LONG

LONG locale dependent date or time style.

See Also:
  Constant Field Values

#### MEDIUM

    public static final int MEDIUM

MEDIUM locale dependent date or time style.

See Also:
  Constant Field Values

#### SHORT

    public static final int SHORT

SHORT locale dependent date or time style.

See Also:
  Constant Field Values

### Constructor Detail

#### FastDatePrinter

    protected FastDatePrinter​(String pattern,
                              TimeZone timeZone,
                              Locale locale)

Constructs a new FastDatePrinter. Use `FastDateFormat.getInstance(String, TimeZone, Locale)` or another variation of the factory methods of `FastDateFormat` to get a cached FastDatePrinter instance.

Parameters:
  `pattern` - `SimpleDateFormat` compatible pattern
  `timeZone` - non-null time zone to use
  `locale` - non-null locale to use
Throws:
  `NullPointerException` - if pattern, timeZone, or locale is null.

### Method Detail

#### parsePattern

    protected List<org.sqlite.date.FastDatePrinter.Rule> parsePattern()

Returns a list of Rules given a pattern.

Returns:
  a `List` of Rule objects
Throws:
  `IllegalArgumentException` - if pattern is invalid

#### parseToken

    protected String parseToken​(String pattern,
                                int[] indexRef)

Performs the parsing of tokens.

Parameters:
  `pattern` - the pattern
  `indexRef` - index references
Returns:
  parsed token

#### selectNumberRule

    protected org.sqlite.date.FastDatePrinter.NumberRule selectNumberRule​(int field,
                                                                          int padding)

Gets an appropriate rule for the padding required.

Parameters:
  `field` - the field to get a rule for
  `padding` - the padding required
Returns:
  a new rule with the correct padding

#### format

    public StringBuffer format​(Object obj,
                               StringBuffer toAppendTo,
                               FieldPosition pos)

Formats a `Date`, `Calendar` or `Long` (milliseconds) object.

Specified by:
  `format` in interface `DatePrinter`
Parameters:
  `obj` - the object to format
  `toAppendTo` - the buffer to append to
  `pos` - the position - ignored
Returns:
  the buffer passed in

#### format

    public String format​(long millis)

Description copied from interface: `DatePrinter`
Formats a millisecond `long` value.

Specified by:
  `format` in interface `DatePrinter`
Parameters:
  `millis` - the millisecond value to format
Returns:
  the formatted string

#### format

    public String format​(Date date)

Description copied from interface: `DatePrinter`
Formats a `Date` object using a `GregorianCalendar`.

Specified by:
  `format` in interface `DatePrinter`
Parameters:
  `date` - the date to format
Returns:
  the formatted string

#### format

    public String format​(Calendar calendar)

Description copied from interface: `DatePrinter`
Formats a `Calendar` object.

Specified by:
  `format` in interface `DatePrinter`
Parameters:
  `calendar` - the calendar to format
Returns:
  the formatted string

#### format

    public StringBuffer format​(long millis,
                               StringBuffer buf)

Description copied from interface: `DatePrinter`
Formats a millisecond `long` value into the supplied `StringBuffer`.

Specified by:
  `format` in interface `DatePrinter`
Parameters:
  `millis` - the millisecond value to format
  `buf` - the buffer to format into
Returns:
  the specified string buffer

#### format

    public StringBuffer format​(Date date,
                               StringBuffer buf)

Description copied from interface: `DatePrinter`
Formats a `Date` object into the supplied `StringBuffer` using a `GregorianCalendar`.

Specified by:
  `format` in interface `DatePrinter`
Parameters:
  `date` - the date to format
  `buf` - the buffer to format into
Returns:
  the specified string buffer

#### format

    public StringBuffer format​(Calendar calendar,
                               StringBuffer buf)

Description copied from interface: `DatePrinter`
Formats a `Calendar` object into the supplied `StringBuffer`.

Specified by:
  `format` in interface `DatePrinter`
Parameters:
  `calendar` - the calendar to format
  `buf` - the buffer to format into
Returns:
  the specified string buffer

#### applyRules

    protected StringBuffer applyRules​(Calendar calendar,
                                      StringBuffer buf)

Performs the formatting by applying the rules to the specified calendar.

Parameters:
  `calendar` - the calendar to format
  `buf` - the buffer to format into
Returns:
  the specified string buffer

#### getPattern

    public String getPattern()

Description copied from interface: `DatePrinter`
Gets the pattern used by this printer.

Specified by:
  `getPattern` in interface `DatePrinter`
Returns:
  the pattern, `SimpleDateFormat` compatible

#### getTimeZone

    public TimeZone getTimeZone()

Description copied from interface: `DatePrinter`
Gets the time zone used by this printer.

This zone is always used for `Date` printing.

Specified by:
  `getTimeZone` in interface `DatePrinter`
Returns:
  the time zone

#### getLocale

    public Locale getLocale()

Description copied from interface: `DatePrinter`
Gets the locale used by this printer.

Specified by:
  `getLocale` in interface `DatePrinter`
Returns:
  the locale

#### getMaxLengthEstimate

    public int getMaxLengthEstimate()

Gets an estimate for the maximum string length that the formatter will produce.

The actual formatted length will almost always be less than or equal to this amount.

Returns:
  the maximum formatted length

#### equals

    public boolean equals​(Object obj)

Compares two objects for equality.

Overrides:
  `equals` in class `Object`
Parameters:
  `obj` - the object to compare to
Returns:
  `true` if equal

#### hashCode

    public int hashCode()

Returns a hashcode compatible with equals.

Overrides:
  `hashCode` in class `Object`
Returns:
  a hashcode compatible with equals

#### toString

    public String toString()

Gets a debugging string version of this formatter.

Overrides:
  `toString` in class `Object`
Returns:
  a debugging string